#!/usr/bin/env sh

#
# Copyright(c) 2006-2016 ThreatSTOP, Inc. All Rights Reserved
#
# NOTICE: All information contained herein is, and remains the property
# of ThreatSTOP, Inc. and its suppliers, if any. The intellectual and 
# technical concepts contained herein are proprietary to ThreatSTOP, Inc. 
# and its suppliers and certain aspects thereof are protected by United 
# States Patent No. 8,533,822 and United States Patent No. 8,869,237, 
# and are protected by trade secret or copyright law.
#
# US Government Entities: The ThreatSTOP service, software and
# documentation, as applicable, are "commercial computer software" and
# "commercial computer software documentation" developed exclusively at
# private expense by Threatstop, Inc. ("Threatstop"). Pursuant to FAR
# 12.212 or DFARS 227 7202 and their successors, as applicable, use,
# reproduction and disclosure of the software and documentation is
# governed by the terms of Threatstop's commercial agreement.
#

#
# Script to make sure your ThreatSTOP block list is ready.
#
# After creating a new device on the ThreatSTOP web site, it can take up
# to 15 minutes before it will start to work. This script can be run to make
# sure your block lists are ready before running the main threatstop-pf.sh 
# script.
#
###############################################################################

CONFIG="/usr/local/etc/threatstop.conf"

# Check for and read the config file, abort if not found
if [ ! -f $CONFIG ]
then
	echo "ALERT: Cannot read config file: \"$CONFIG\""
	echo "Exiting"
	exit 1
else
	. $CONFIG
fi

for DNS in $DNS_SERVERS
do
        RUN=`dig @$DNS $BLOCK_LIST PTR | sed -n -f ptr.sed |wc -l`
        if [ $RUN -gt 0 ]
        then
		OKDNSLIST="$OKDNSLIST $DNS"
		echo "DNS Server $DNS is ready."
        else
		echo "DNS Server $DNS failed."
	fi
done

if [ `echo $OKDNSLIST | wc -w` -eq 0 ]
then
	cat <<EOF

The test FAILED.

If this is a new device please wait a few minutes and try again. If it still 
does not work within a hour of creating your device on the web page, please 
contact support for assistance.

support@threatstop.com
+1 (760) 542-1550

EOF
        exit 1
else
	echo;echo "The test was successful. You are now ready to run the threatstop-pf.sh script."
fi

